////////////////////////////////////////////////////////////////
//  GJVOG.HPP, Header file and class declarations for cGJVOG
//
//
//
////////////////////////////////////////////////////////////////
//  Handle the compiler specific declarations
#ifndef __TURBOC__
#ifndef ZORTECH
#error  Compiler must be defined
#endif
#endif
////////////////////////////////////////////////////////////////
//  TC++ Specifics
////////////////////////////////////////////////////////////////
#ifdef __TURBOC__
#define RANDMAX(a)  random(a)
#define MOV(t,s)  t = s
#define OUT(p,w)  outport( p, w )
#define OR(s,o,v)  v = *( (char *) MK_FP( s, o ) )
#define MOVBP(s,o,v)  *( (char *) MK_FP( s, o ) ) = (char)v;
#endif
////////////////////////////////////////////////////////////////
// ZORTECH Specifics
////////////////////////////////////////////////////////////////
#ifdef ZORTECH
#define RANDMAX(a)  ( rand() % a )
#define MOV(t,s)  t = s
#define OUT(p,w)  outpw( p, w )
#define OR(s,o,v)  v = *( (char *) MK_FP( s, o ) )
#define MOVBP(s,o,v)  *( (char *) MK_FP( s, o ) ) = (char)v;
#endif
// end of compiler specific definitions
////////////////////////////////////////////////////////////////
//
//
//
//
////////////////////////////////////////////////////////////////
// Video zone structure declaration
typedef struct VIDEOZONE {
        int l;
        int t;
        int r;
        int b;
        } VZH;
////////////////////////////////////////////////////////////////
//
//
//
//
////////////////////////////////////////////////////////////////
//  Macros of no value outside of the 808XX family
#include <dos.h>
#include <conio.h>
#define AH uAX.bb.h
#define AL uAX.bb.l
#define BH uBX.bb.h
#define BL uBX.bb.l
#define CH uCX.bb.h
#define CL uCX.bb.l
#define DH uDX.bb.h
#define DL uDX.bb.l
#define AX uAX.w
#define BX uBX.w
#define CX uCX.w
#define DX uDX.w
// end of macros specific to intel
////////////////////////////////////////////////////////////////
//
//
//
//
////////////////////////////////////////////////////////////////
// Portable macros
#define sign(x) ((x)>0?1:((x)==0?0:(-1)))
////////////////////////////////////////////////////////////////
//  Class cGJVGR declaration
//
//
//
////////////////////////////////////////////////////////////////
class cGJVGR {
private:

    double max_x;
    double max_y;
    double min_x;
    double min_y;
    int      mode_set;
    int     linewidth;
    int   mode_pushed;
    int    last_color;
    int        last_x;
    int        last_y;
    int      scaled_x;
    int      scaled_y;
    long      pattern;
    union REGS      r;
    unsigned char *palette;
    struct VIDEOZONE vz;

protected:

    int restore_palette();
    int set_mode( int mtp, int mts );
    int set_palette( int pal, int color );

public:

    cGJVGR( int mode );
    int setminmax( double minx, double miny, double maxx, double maxy );
    int update( int x, int y, int color );
    int set_linewidth( int width );
    int border( int color );
    int set_scaled_x( double x );
    int set_scaled_y( double y );
    int point( double x, double y, int color );
    int point( int x, int y, int color );
    void drain();
    int wipe( int bkcolor );
    int line( int x1, int y1, int x2, int y2, int color );
    int right();
    int bottom();

}; // end of cGJVGR
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
//  End of GJVOG.HPP
//  Garry J. Vass  (72307,3311)
////////////////////////////////////////////////////////////////
